Index: base/notifications.c
===================================================================
--- base/notifications.c	(revision 1824)
+++ base/notifications.c	(working copy)
@@ -223,26 +223,6 @@
 		/* free memory allocated to the notification list */
 		free_notification_list();
 
-		/* clear out all macros we created */
-		my_free(mac.x[MACRO_NOTIFICATIONNUMBER]);
-		my_free(mac.x[MACRO_SERVICENOTIFICATIONNUMBER]);
-		my_free(mac.x[MACRO_SERVICENOTIFICATIONID]);
-		my_free(mac.x[MACRO_NOTIFICATIONCOMMENT]);
-		my_free(mac.x[MACRO_NOTIFICATIONTYPE]);
-		my_free(mac.x[MACRO_NOTIFICATIONAUTHOR]);
-		my_free(mac.x[MACRO_NOTIFICATIONAUTHORNAME]);
-		my_free(mac.x[MACRO_NOTIFICATIONAUTHORALIAS]);
-		my_free(mac.x[MACRO_SERVICEACKAUTHORNAME]);
-		my_free(mac.x[MACRO_SERVICEACKAUTHORALIAS]);
-		my_free(mac.x[MACRO_SERVICEACKAUTHOR]);
-		my_free(mac.x[MACRO_SERVICEACKCOMMENT]);
-
-		/* this gets set in add_notification() */
-		my_free(mac.x[MACRO_NOTIFICATIONRECIPIENTS]);
-
-		/* clear summary macros so they will be regenerated without contact filters when needed next */
-		clear_summary_macros_r(&mac);
-
 		if(type == NOTIFICATION_NORMAL) {
 
 			/* adjust last/next notification time and notification flags if we notified someone */
@@ -300,6 +280,9 @@
 	/* update the status log with the service information */
 	update_service_status(svc, FALSE);
 
+        /* clear volatile macros */
+        clear_volatile_macros_r(&mac);
+
 	return OK;
 	}
 
@@ -1170,25 +1153,6 @@
 		/* free memory allocated to the notification list */
 		free_notification_list();
 
-		/* clear out all macros we created */
-		my_free(mac.x[MACRO_HOSTNOTIFICATIONID]);
-		my_free(mac.x[MACRO_NOTIFICATIONNUMBER]);
-		my_free(mac.x[MACRO_NOTIFICATIONCOMMENT]);
-		my_free(mac.x[MACRO_HOSTNOTIFICATIONNUMBER]);
-		my_free(mac.x[MACRO_NOTIFICATIONTYPE]);
-		my_free(mac.x[MACRO_NOTIFICATIONAUTHOR]);
-		my_free(mac.x[MACRO_NOTIFICATIONAUTHORNAME]);
-		my_free(mac.x[MACRO_NOTIFICATIONAUTHORALIAS]);
-		my_free(mac.x[MACRO_HOSTACKAUTHORNAME]);
-		my_free(mac.x[MACRO_HOSTACKAUTHORALIAS]);
-		my_free(mac.x[MACRO_HOSTACKAUTHOR]);
-		my_free(mac.x[MACRO_HOSTACKCOMMENT]);
-		/* this gets set in add_notification() */
-		my_free(mac.x[MACRO_NOTIFICATIONRECIPIENTS]);
-
-		/* clear summary macros so they will be regenerated without contact filters when needednext */
-		clear_summary_macros_r(&mac);
-
 		if(type == NOTIFICATION_NORMAL) {
 
 			/* adjust last/next notification time and notification flags if we notified someone */
@@ -1243,6 +1207,9 @@
 	/* update the status log with the host info */
 	update_host_status(hst, FALSE);
 
+        /* clear volatile macros */
+        clear_volatile_macros_r(&mac);
+
 	return OK;
 	}
 
